# PNotifierTemplate< ParmType > Class Template Reference

The `PNotifier` and `PNotifierFunction` classes build a completely type safe mechanism for calling arbitrary member functions on classes. More...

`#include <notifier.h>`

Inheritance diagram for PNotifierTemplate< ParmType >:

List of all members.

## Public Member Functions

| PNotifierTemplate (PNotifierFunctionTemplate< ParmType > *func=NULL)
| Create a new notification function smart pointer.
virtual void | operator() (PObject &notifier, ParmType extra) const
| Execute the call to the actual notification function on the object instance contained in this object.

## Detailed Description

### template<typename ParmType>
class PNotifierTemplate< ParmType >

The `PNotifier` and `PNotifierFunction` classes build a completely type safe mechanism for calling arbitrary member functions on classes.

The "pointer to a member function" capability built into C++ makes the assumption that the function name exists in an ancestor class. If you wish to call a member function name that does {not} exist in any ancestor class, very type unsafe casting of the member functions must be made. Some compilers will even refuse to do it at all!

To overcome this problem, as this mechanism is highly desirable for callback functions in the GUI part of the PTLib library, these classes and a macro are used to create all the classes and declarations to use polymorphism as the link between the caller, which has no knowledege of the function, and the receiver object and member function.

This is most often used as the notification of actions being take by interactors in the PTLib library.

## Constructor & Destructor Documentation

template<typename ParmType>

PNotifierTemplate< ParmType >::PNotifierTemplate | ( | PNotifierFunctionTemplate< ParmType > * | func = `NULL` | ) | `[inline]`

Create a new notification function smart pointer.

Parameters:

  func | Notifier function to call.

## Member Function Documentation

template<typename ParmType>

virtual void PNotifierTemplate< ParmType >::operator() | ( | PObject & | notifier,
|  | ParmType | extra |
| ) |  |  | const`[inline, virtual]`

Execute the call to the actual notification function on the object instance contained in this object.

This will make a polymorphic call to the function declared by the `PDECLARE_NOTIFIER` macro which in turn calls the required function in the destination object.

Parameters:

  notifier | Object that is making the notification.
  extra | Extra information that may be passed to function.

The documentation for this class was generated from the following file:

- notifier.h